searchNodes=[{"ref":"Shoehorn.html","title":"Shoehorn","type":"module","doc":""},{"ref":"Shoehorn.html#after_assembly/2","title":"Shoehorn.after_assembly/2","type":"function","doc":"See Shoehorn.Plugin.after_assembly/2."},{"ref":"Shoehorn.html#after_cleanup/2","title":"Shoehorn.after_cleanup/2","type":"function","doc":"See Shoehorn.Plugin.after_cleanup/2."},{"ref":"Shoehorn.html#after_package/2","title":"Shoehorn.after_package/2","type":"function","doc":"See Shoehorn.Plugin.after_package/2."},{"ref":"Shoehorn.html#before_assembly/2","title":"Shoehorn.before_assembly/2","type":"function","doc":"See Shoehorn.Plugin.before_assembly/2."},{"ref":"Shoehorn.html#before_package/2","title":"Shoehorn.before_package/2","type":"function","doc":"See Shoehorn.Plugin.before_package/2."},{"ref":"Shoehorn.html#boot/1","title":"Shoehorn.boot/1","type":"function","doc":""},{"ref":"Shoehorn.html#children/0","title":"Shoehorn.children/0","type":"function","doc":""},{"ref":"Shoehorn.html#start/2","title":"Shoehorn.start/2","type":"function","doc":"Called when an application is started. This function is called when an application is started using Application.start/2 (and functions on top of that, such as Application.ensure_started/2). This function should start the top-level process of the application (which should be the top supervisor of the application&#39;s supervision tree if the application follows the OTP design principles around supervision). start_type defines how the application is started: :normal - used if the startup is a normal startup or if the application is distributed and is started on the current node because of a failover from another node and the application specification key :start_phases is :undefined. {:takeover, node} - used if the application is distributed and is started on the current node because of a failover on the node node. {:failover, node} - used if the application is distributed and is started on the current node because of a failover on node node, and the application specification key :start_phases is not :undefined. start_args are the arguments passed to the application in the :mod specification key (e.g., mod: {MyApp, [:my_args]}). This function should either return {:ok, pid} or {:ok, pid, state} if startup is successful. pid should be the PID of the top supervisor. state can be an arbitrary term, and if omitted will default to []; if the application is later stopped, state is passed to the stop/1 callback (see the documentation for the c:stop/1 callback for more information). use Application provides no default implementation for the start/2 callback. Callback implementation for Application.start/2."},{"ref":"Shoehorn.ApplicationController.html","title":"Shoehorn.ApplicationController","type":"module","doc":""},{"ref":"Shoehorn.ApplicationController.html#app/1","title":"Shoehorn.ApplicationController.app/1","type":"function","doc":""},{"ref":"Shoehorn.ApplicationController.html#application_ebin/1","title":"Shoehorn.ApplicationController.application_ebin/1","type":"function","doc":""},{"ref":"Shoehorn.ApplicationController.html#application_exists?/1","title":"Shoehorn.ApplicationController.application_exists?/1","type":"function","doc":""},{"ref":"Shoehorn.ApplicationController.html#application_lib_dir/1","title":"Shoehorn.ApplicationController.application_lib_dir/1","type":"function","doc":""},{"ref":"Shoehorn.ApplicationController.html#application_spec/1","title":"Shoehorn.ApplicationController.application_spec/1","type":"function","doc":""},{"ref":"Shoehorn.ApplicationController.html#child_spec/1","title":"Shoehorn.ApplicationController.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Shoehorn.ApplicationController.html#filter_apps/1","title":"Shoehorn.ApplicationController.filter_apps/1","type":"function","doc":""},{"ref":"Shoehorn.ApplicationController.html#init/1","title":"Shoehorn.ApplicationController.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Shoehorn.ApplicationController.html#reject_missing_apps/1","title":"Shoehorn.ApplicationController.reject_missing_apps/1","type":"function","doc":""},{"ref":"Shoehorn.ApplicationController.html#start_link/1","title":"Shoehorn.ApplicationController.start_link/1","type":"function","doc":""},{"ref":"Shoehorn.Handler.html","title":"Shoehorn.Handler","type":"behaviour","doc":"A behaviour module for implementing handling of failing applications A Shoehorn.Handler is a module that knows how to respond to specific applications going down. There are two types of failing applications. The first is an application that fails to initialize and the second is an application that stops while it is running. Example The Shoehorn.Handler behaviour requires developers to implement two callbacks. The init callback sets up any state the handler needs. Ther application_started callback is called when an application starts up. The application_exited callback processes the incoming failure and replies with the reaction that Shoehorn should take in case of application failure. defmodule Example.ShoehornHandler do use Shoehorn.Handler def init(_opts) do {:ok, %{restart_counts: 0}} end def application_started(app, state) do {:continue, state} end def application_exited(:non_essential_app, _reason, state) do {:continue, state} end def application_exited(:essential_app, _reason, %{restart_counts: restart_counts} = state) when restart_counts &lt; 2 do # repair actions to make before restarting Application.ensure_all_started(:essential_app) {:continue, %{state | restart_counts: restart_counts + 1}} end def applicaton_exited(_, state) do {:halt, state} end end We initialize our Shoehorn.Handler with a restart count for state by calling init with the configuration options from our shoehorn config. The stored state is passed in from the Shoehorn.ApplicationController. When we have an application startup, we will put a message on the console to notify the developer. When we have a non-essential application fail we return :continue to inform the system to keep going like nothing happened. We restart the essential application of our system two times, and then we tell the system to halt if starting over wasn&#39;t fixing the system."},{"ref":"Shoehorn.Handler.html#c:application_exited/3","title":"Shoehorn.Handler.application_exited/3","type":"callback","doc":"Callback for handling application crashes Called with the application name, cause, and the handler&#39;s state. It must return a tuple contaning the reaction that the Shoehorn.ApplicationController should take, and the new state of the handler. The code that you execute here can be used to notify or capture some information before halting the system. This information can later be used to recreate the issue or debug the problem causing the application to exit. Use application_exited as a place for a last-ditch effort to fix the issue and restart the application. Ideally, capture some information on the system state, and solve it upstream. Shoehorn restarts should be used as a splint to keep a critical system running. The default implementation returns the previous state, and a :halt reaction."},{"ref":"Shoehorn.Handler.html#c:application_started/2","title":"Shoehorn.Handler.application_started/2","type":"callback","doc":"Callback for handling application starts Called with the application name, and the handler&#39;s state. It must return a tuple containing the reaction that the Shoehorn.ApplicationController should take, and the new state of the handler. def application_exited(:essential_app, _reason, state) do # repair actions to make before restarting # notify someone of the crash and the details # log debug data Application.ensure_all_started(:essential_app) {:continue, %{state | restart_counts: restart_counts + 1}} end The default implementation returns unchanged state, and a :continue reaction."},{"ref":"Shoehorn.Handler.html#init/1","title":"Shoehorn.Handler.init/1","type":"function","doc":""},{"ref":"Shoehorn.Handler.html#c:init/1","title":"Shoehorn.Handler.init/1","type":"callback","doc":"Callback to initialize the handle The callback must return a tuple of {:ok, state}. Where state is the initial state of the handler. The system will halt if the return is anything other than :ok."},{"ref":"Shoehorn.Handler.html#invoke/3","title":"Shoehorn.Handler.invoke/3","type":"function","doc":""},{"ref":"Shoehorn.Handler.html#invoke/4","title":"Shoehorn.Handler.invoke/4","type":"function","doc":""},{"ref":"Shoehorn.Handler.html#t:cause/0","title":"Shoehorn.Handler.cause/0","type":"type","doc":"The cause that is firing the handler"},{"ref":"Shoehorn.Handler.html#t:opts/0","title":"Shoehorn.Handler.opts/0","type":"type","doc":""},{"ref":"Shoehorn.Handler.html#t:reaction/0","title":"Shoehorn.Handler.reaction/0","type":"type","doc":"The reaction letting Shoehorn.ApplicationController know what to do :continue - keep the system going like nothing happened :halt - stop the application and bring the system down"},{"ref":"Shoehorn.Handler.html#t:t/0","title":"Shoehorn.Handler.t/0","type":"type","doc":""},{"ref":"Shoehorn.Plugin.html","title":"Shoehorn.Plugin","type":"module","doc":""},{"ref":"Shoehorn.Plugin.html#after_assembly/1","title":"Shoehorn.Plugin.after_assembly/1","type":"function","doc":""},{"ref":"Shoehorn.Plugin.html#after_assembly/2","title":"Shoehorn.Plugin.after_assembly/2","type":"function","doc":"Called after assembling the release. Should return a modified %Release{} or nil. Callback implementation for Distillery.Releases.Plugin.after_assembly/2."},{"ref":"Shoehorn.Plugin.html#after_cleanup/2","title":"Shoehorn.Plugin.after_cleanup/2","type":"function","doc":"Called when the user invokes the mix distillery.release.clean task. The callback will be passed the command line arguments to mix distillery.release.clean. It should clean up the files the plugin created. The return value of this callback is ignored. Callback implementation for Distillery.Releases.Plugin.after_cleanup/2."},{"ref":"Shoehorn.Plugin.html#after_package/1","title":"Shoehorn.Plugin.after_package/1","type":"function","doc":""},{"ref":"Shoehorn.Plugin.html#after_package/2","title":"Shoehorn.Plugin.after_package/2","type":"function","doc":"Called after packaging the release. Should return a modified %Release{} or nil. When in dev_mode, the packaging phase is skipped. Callback implementation for Distillery.Releases.Plugin.after_package/2."},{"ref":"Shoehorn.Plugin.html#before_assembly/1","title":"Shoehorn.Plugin.before_assembly/1","type":"function","doc":""},{"ref":"Shoehorn.Plugin.html#before_assembly/2","title":"Shoehorn.Plugin.before_assembly/2","type":"function","doc":"Called before assembling the release. Should return a modified %Release{} or nil. Callback implementation for Distillery.Releases.Plugin.before_assembly/2."},{"ref":"Shoehorn.Plugin.html#before_package/1","title":"Shoehorn.Plugin.before_package/1","type":"function","doc":""},{"ref":"Shoehorn.Plugin.html#before_package/2","title":"Shoehorn.Plugin.before_package/2","type":"function","doc":"Called before packaging the release. Should return a modified %Release{} or nil. When in dev_mode, the packaging phase is skipped. Callback implementation for Distillery.Releases.Plugin.before_package/2."},{"ref":"Shoehorn.Plugin.html#generate_boot_script/1","title":"Shoehorn.Plugin.generate_boot_script/1","type":"function","doc":""},{"ref":"Shoehorn.Release.html","title":"Shoehorn.Release","type":"module","doc":""},{"ref":"Shoehorn.Release.html#init/1","title":"Shoehorn.Release.init/1","type":"function","doc":""},{"ref":"Shoehorn.Release.html#load_apps/1","title":"Shoehorn.Release.load_apps/1","type":"function","doc":""},{"ref":"Shoehorn.Release.html#start_apps/1","title":"Shoehorn.Release.start_apps/1","type":"function","doc":""},{"ref":"Shoehorn.Utils.html","title":"Shoehorn.Utils","type":"module","doc":""},{"ref":"Shoehorn.Utils.html#shoehorn_applications/0","title":"Shoehorn.Utils.shoehorn_applications/0","type":"function","doc":""},{"ref":"readme.html","title":"Shoehorn","type":"extras","doc":"Shoehorn Shoehorn provides full control over the application lifecycle in Elixir."},{"ref":"readme.html#usage","title":"Shoehorn - Usage","type":"extras","doc":"Shoehorn acts as a shim to the initialization sequence for your application&#39;s VM. Using Shoehorn, you can ensure that the VM will always pass initialization. This provides the running node the ability of using Elixir / Erlang to control the full application lifecycle through the exposure of new system phases. This level of control is important when the Erlang VM is fully responsible for the entire runtime including its own updates. In these situations, if the VM were to fail to start it would never be able to recover from a bad update. This is especially useful when running Nerves. Here&#39;s how it works. Include shoehorn into your application release plugins. # rel/config.exs release :simple_app do set version: current_version(:simple_app) plugin Shoehorn end And produce a release mix release Go to the release directory and boot your app using shoehorn _build/dev/rel/simple_app/bin/simple_app console_boot $(pwd)/_build/dev/rel/simple_app/bin/shoehorn From here we can see that the shoehorn was started, but simple_app was not. iex(simple_app@127.0.0.1)1&gt; Application.started_applications [{:iex, &#39;iex&#39;, &#39;1.4.0&#39;}, {:shoehorn, &#39;shoehorn&#39;, &#39;0.1.0&#39;}, {:elixir, &#39;elixir&#39;, &#39;1.4.0&#39;}, {:compiler, &#39;ERTS CXC 138 10&#39;, &#39;7.0.3&#39;}, {:stdlib, &#39;ERTS CXC 138 10&#39;, &#39;3.2&#39;}, {:kernel, &#39;ERTS CXC 138 10&#39;, &#39;5.1.1&#39;}] Booting the shoehorn.boot script with zero application config will being up the Erlang VM and only run the shoehorn app. Now let&#39;s configure shoehorn to do something more interesting by adding some minimal configuration. # config/config.exs config :shoehorn, app: :my_app, init: [:nerves_runtime, :nerves_init_gadget, :nerves_firmware_ssh] Shoehorn will call Application.ensure_all_started/2 on each app in the init list, followed by the main app. In the example above, the boot sequence would be [:nerves_runtime, :nerves_init_gadget, :my_app]. The init application list should be used to prioritize OTP applications that need to be available to recover from error. In the example above, we initialize the runtime, bring up the network, and ensure we can receive new firmware updates. If my_app were to fail to start, the node would still be in a state where it can receive new firmware over the network. You can also specify an {m, f, a} in the init list for performing simple initialization time tasks. # config/config.exs config :shoehorn, app: :my_app, init: [{IO, :puts, &quot;Init&quot;}, :nerves_runtime]"},{"ref":"readme.html#application-failures","title":"Shoehorn - Application Failures","type":"extras","doc":"The Erlang VM will respond to application failures based off the application start permanence type specified when it was asked to start. There are three permanence types: :permanent - if app terminates, all other applications and the entire node are also terminated. :transient - if app terminates with :normal reason, it is reported but no other applications are terminated. If a transient application terminates abnormally, all other applications and the entire node are also terminated. :temporary - if app terminates, it is reported but no other applications are terminated (the default). Shoehorn will start all applications as :temporary and monitor application events by registering to the erlang kernel error_logger. Application start and exit events will attempt to execute a callback to the configured Shoehorn.Handler module. By default, the module Shoehorn.Handler.Ignore will be called. This module is configured to continue the Erlang VM if any otp application were to exit for any reason. In production, you may want to customize the action on failure so you can gather forensics or perform updates to the node. You can do this by overriding the handler in the prod env of your application config. # config/prod.exs config :shoehorn, handler: MyApp.ShoehornHandler More advanced failure cases can be handled by providing your own module that implements the Shoehorn.Handler behaviour. For example, the erlang :ssh application is prone to exiting when undergoing a brute force attack. Instead of the default production behaviour of forcing the node to restart, we can restart the application. defmodule Example.RestartHandler do use Shoehorn.Handler def application_exited(app, _reason, state) do IO.puts(&quot;Application stopped: \#{inspect(app)} \#{inspect(state)}&quot;) Application.ensure_all_started(app) {:continue, state} end end The application_exited/3 callback is limited in the amount of time is has to execute by setting a shutdown timer. If the callback does not return within the defined shutdown time, the node is instructed to halt. The default shutdown time is 30 seconds but this value can be changed in the application config. # config/config.exs config :shoehorn, shutdown_timer: 50_000 # 50 Seconds Check out the example application for more info on implementing custom strategies."},{"ref":"readme.html#distillery-overrides","title":"Shoehorn - Distillery overrides","type":"extras","doc":"Shoehorn will alter the release defaults to omit :mix and :distillery from the list of default applications to include. If you depend on these applications at runtime, you can add :distillery to the extra_applications list and or :mix to the included_applications list in the application/0 callback in your mix.exs file."}]